期望的计算公式：
$$
E(X)=\sum_i i\times P(x=i)
$$
期望的线性性：
$$
E(X+Y)=E(X)+E(Y),E(kX)=kE(x)
$$


# A [百事世界杯之旅](https://www.luogu.com.cn/problem/P1291)

![image-20240502132049414](C:\Users\HP\AppData\Roaming\Typora\typora-user-images\image-20240502132049414.png) 

考虑倒推，设 $f(x)$ 代表已经收集到 $x$ 个名字后还需要买的饮料的期望次数，有 $f(n)=0$。

当已经收集到 $i$ 个名字的时候，每次有 $\frac{i}{n}$ 的概率买到已有的名字，有 $\frac{n-i}{n}$ 的概率买到新名字，则从 $i$ 到 $i+1$ 的期望步数为
$$
S_i=\sum_{k=0}^\infty (k+1)(\frac{i}{n})^k \frac{n-i}{n}=\frac{n}{n-i}
$$
或者根据下式得出：
$$
f(i)=1+\frac{i}{n}f(i)+\frac{n-i}{n}f(i+1)
$$
最终递推得到 $f(0)$ 的结果就是最终答案。

# B [收集邮票](https://www.luogu.com.cn/problem/P4550)

![image-20240502132119074](C:\Users\HP\AppData\Roaming\Typora\typora-user-images\image-20240502132119074.png)

如果最终买了 $m$ 次邮票，则最终花费为 $(m+1)m/2$。所以最终的花费只与买的次数相关。

由于期望的线性性，$E((m+1)m/2)=\frac 12[E(m^2)+E(m)]$，需要分别维护 $m$ 的期望和 $m^2$ 的期望。

对于 $m$ 的期望，我们令 $f(x)$ 代表现在有 $x$ 张邮票时拿满 $n$ 张的期望步数，根据上一题的结论有 $f(x+1)=f(x)+\frac{n}{n-x}$，计算出 $f(0)$ 就是 $m$ 的期望。

对于 $m^2$ 的期望，令 $g(x)$ 代表有 $x$ 张邮票时拿满 $n$ 张的步数平方的期望，$p_1(i),p_2(i)$ 分别代表有 $x,x+1$ 张时通过 $i$ 步拿满 $n$ 张的概率，则
$$
f(x)=\sum_{i}ip_1(i),f(x+1)=\sum_ip_2(i)\\
g(x)=\sum_{i}i^2p_1(i),g(x+1)=\sum_ii^2p_2(i)\\
p_1(i)=\sum_{j<i}p_2(j)\times (\frac{x}{n})^{i-j-1}\times \frac{n-x}{n}\\
$$

$$
g(x)=\sum_ii^2\sum_{j<i}p_2(j)\times \frac{(n-x)x^{i-j-1}}{n^{i-j}}=\frac{n-x}{x}\sum_ii^2\sum_{j<i}p_2(j)\times \frac{x^{i-j}}{n^{i-j}}\\
g(x)=\frac{n-x}{x}\sum_i p_2(i)\times \sum_{j>i}j^2(\frac{x}{n})^{i-j}
$$

$$
\sum_{j=1}^\infty (i+j)^2A^j=i^2\sum A^j+2i\sum jA^j+\sum j^2A^j
$$

化简可得
$$
g(x+1)=\frac{2i}{n-i}f(x+1)+\frac{i}{n-i}+g(x)+2f(x)+1
$$

# C [概率充电器](https://www.luogu.com.cn/problem/P4284)

![image-20240502131107977](C:\Users\HP\AppData\Roaming\Typora\typora-user-images\image-20240502131107977.png)

![image-20240502131117445](C:\Users\HP\AppData\Roaming\Typora\typora-user-images\image-20240502131117445.png)

假设以 $1$ 号点为根，那么每个点来电的情况可分为三类：

- 直接进行充电
- 从子树内部传来
- 从父节点处传来

如果只考虑前两种情况，设点 $i$ 直接充上电的概率为 $p_i$，能够通电的总概率为 $f_i$，则
$$
f_i=p_i+(1-p_i)\times \bigg[1-\prod_{v\in son_u}(1-f_v)\bigg]
$$
由于根节点没有父节点，所以根节点的 $f$ 值就是答案，直接进行换根 DP 就可以得到每个点的答案。

# D [游戏](https://www.luogu.com.cn/problem/P4562)

![image-20240502132529749](C:\Users\HP\AppData\Roaming\Typora\typora-user-images\image-20240502132529749.png)

![image-20240502155931593](C:\Users\HP\AppData\Roaming\Typora\typora-user-images\image-20240502155931593.png)

考虑所有满足其不是 $[l,r]$ 中任意一个它自己以外的数的倍数的数，这些数只能通过自己被检查才能被标记。那么这些数里面最后一个被检查到的数的下标就是 $t(p)$。记这样的数为关键点，问题化为求最后一个关键点的期望位置。

可以计算每一个位置作为最后的位置的情况数。假设关键点个数为 $k$，这个位置需要放置一个关键点，并且剩下的 $k-1$ 个关键点需要放在这个位置前面。这样得到这个位置的合法情况数为
$$
\binom{k-1}{i-1}\times k!\times (n-k)!
$$
计算出所有位置的合法情况数相加即可。

# E [亚瑟王](https://www.luogu.com.cn/problem/P3239)

![image-20240502133733435](C:\Users\HP\AppData\Roaming\Typora\typora-user-images\image-20240502133733435.png)

![image-20240502133752177](C:\Users\HP\AppData\Roaming\Typora\typora-user-images\image-20240502133752177.png)

根据期望的线性性，一套卡牌造成伤害的期望值等于每张牌造成伤害的期望值之和。

一张牌造成伤害的期望等于它的伤害乘上它触发的概率。

而每张牌被经过一次判定当且仅当这一轮它前面的牌都没有判定通过，所以编号为 $i$ 的牌一共被判定 $r-j$ 次的概率就是前面 $i-1$ 张牌在这 $r$ 轮中有 $j$ 张牌成功发动了技能的概率。

记 $f_{i,j}$ 代表前 $i$ 张牌中有 $j$ 张牌发动技能的概率，则
$$
f_{i,j}=f_{i-1,j}\times (1-p_i)^{r-j}+f_{i-1,j-1}\times [1-(1-p_i)^{r-j+1}]
$$
那么第 $i$ 张牌触发的概率就是
$$
\sum_{j=0}^{\min(r,i-1)}f_{i-1,j}\times [1-(1-p_i)^{r-j}]
$$
时间复杂度 $O(Tnr)$